# Compatibility with RHEL. These macros have been added to EPEL but
# not yet to RHEL proper.
# https://bugzilla.redhat.com/show_bug.cgi?id=1307190
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%{!?py2_build: %global py2_build %{expand: CFLAGS="%{optflags}" %{__python2} setup.py %{?py_setup_args} build --executable="%{__python2} -s"}}
%{!?py2_install: %global py2_install %{expand: CFLAGS="%{optflags}" %{__python2} setup.py %{?py_setup_args} install -O1 --skip-build --root %{buildroot}}}

Name:       locmap
Version:    2.0.5
Release:    1%{?dist}
Summary:    Local Configuration with Masterless Puppet
Group:      CERN/Utilities
License:    BSD
URL:        http://linux.cern.ch
Source0:    https://gitlab.cern.ch/linuxsupport/locmap/%{name}-%{version}.tar.gz

BuildArch:      noarch

BuildRequires:  python-devel
BuildRequires:  python-setuptools

Obsoletes: lcm
Obsoletes: ccm
Obsoletes: lcm-profile
Obsoletes: lcm-firstboot
Obsoletes: ncm-ncd
Obsoletes: ncm-template
Obsoletes: ncm-afsclt ncm-chkconfig ncm-krb5clt ncm-ncd ncm-nscd
Obsoletes: ncm-ntpd ncm-ocsagent ncm-sendmail ncm-srvtab ncm-ssh

# Needed for CC74 -> CC75 because of epoch on our hiera
Obsoletes: hiera

Provides: lcm
Provides: lcm-profile

Requires: python-ldap
Requires: python-netaddr
Requires: krb5-workstation
Requires: PyYAML
Requires: useraddcern
Requires: iproute
Requires: bind-utils
Requires: python-setuptools

Requires: puppet-agent >= 1.9
Requires: locmap-plugin-puppet-facts
Requires: locmap-plugin-xldap

# Default modules
%if 0%{?rhel} >= 7
Requires: puppet-afs
Requires: puppet-cernbox
Requires: puppet-concat
Requires: puppet-cvmfs
Requires: puppet-eosclient
Requires: puppet-firewalld
Requires: puppet-gpg
Requires: puppet-inifile
Requires: puppet-kerberos
Requires: puppet-keytab
Requires: puppet-lpadmin
Requires: puppet-nscd
Requires: puppet-ntp
Requires: puppet-sendmail
Requires: puppet-ssh
Requires: puppet-stdlib
Requires: puppet-sudo
%endif

%description
Local Configuration with Masterless Puppet and its plugins

%package plugin-xldap
Summary:        locmap input plugin / CERN xldap
Group:          CERN/Utilities

Requires:       locmap

%description plugin-xldap
locmap input plugin / CERN xldap

%package plugin-puppet-facts
Summary:        locmap input plugin / Puppet facts
Group:          CERN/Utilities

Requires:       locmap

%description plugin-puppet-facts
locmap input plugin / Puppet facts

%prep
%setup -q

%build
%py2_build

%install
%{__rm} -rf %{buildroot}
%py2_install

rm -rf %{buildroot}/%{python2_sitelib}/tests

install -dm 755 %{buildroot}%{_sysconfdir}/%{name}
install -dm 755 %{buildroot}%{_sysconfdir}/%{name}/enabled
install -dm 755 %{buildroot}%{_sysconfdir}/%{name}/code/environments/production/hieradata
install -dm 755 %{buildroot}%{_sysconfdir}/%{name}/code/environments/production/hieradata/modules
install -dm 755 %{buildroot}%{_sysconfdir}/%{name}/code/environments/production/hieradata/users
install -dm 755 %{buildroot}/%{_datadir}/man/man1
install -dm 755 %{buildroot}/%{_datadir}/puppet/modules

install -m 0644 etc/site.pp  %{buildroot}%{_sysconfdir}/%{name}/site.pp
install -m 0644 etc/locmap.conf  %{buildroot}%{_sysconfdir}/%{name}/locmap.conf
install -m 0644 etc/hiera.yaml  %{buildroot}%{_sysconfdir}/%{name}/hiera.yaml

install -m 0644 man/locmap.1.gz %{buildroot}/%{_datadir}/man/man1/

%files plugin-xldap
%{python2_sitelib}/%{name}/input_plugins/xldap*

%files plugin-puppet-facts
%{python2_sitelib}/%{name}/input_plugins/facts*

%files
%defattr(-,root,root)
%{_bindir}/*
%dir %{_sysconfdir}/locmap/enabled
%dir %{_sysconfdir}/locmap/code/environments/production/hieradata/modules
%dir %{_sysconfdir}/locmap/code/environments/production/hieradata/users
%dir %{_datadir}/puppet/modules
%config(noreplace) %{_sysconfdir}/locmap/locmap.conf
%{_mandir}/man1/locmap.1.gz
%{_sysconfdir}/locmap/site.pp
%{_sysconfdir}/locmap/hiera.yaml
%{python2_sitelib}/%{name}*
%exclude %{python2_sitelib}/%{name}/input_plugins/facts*
%exclude %{python2_sitelib}/%{name}/input_plugins/xldap*
%doc LICENSE README.rst AUTHORS.rst CONTRIBUTING.rst

%changelog
* Wed Jul 11 2018 Thomas Oulevey <thomas.oulevey@cern.ch> - 2.0.5-1
- fix bug LOS-184 : .strip function error.

* Mon Jun 04 2018 Thomas Oulevey <thomas.oulevey@cern.ch> - 2.0.4-1
- fix KeyError in xldap ssh key fetching.
- fix dn for user's search function

* Fri May 11 2018 Thomas Oulevey <thomas.oulevey@cern.ch> - 2.0.3-1
- fix Requires for default modules
- fix user message for none existing module
- Add better logging to file

* Fri May 11 2018 Thomas Oulevey <thomas.oulevey@cern.ch> - 2.0.1-1
- fix none CERN machine
- set -> list for yaml

* Mon May 07 2018 Thomas Oulevey <thomas.oulevey@cern.ch> - 2.0.0-9
- relax puppet-agent requires to >= 1.9

* Mon May 07 2018 Thomas Oulevey <thomas.oulevey@cern.ch> - 2.0.0-8
- Run input plugins only when needed
- Better domain detection if ipv6 local link

* Mon May 07 2018 Thomas Oulevey <thomas.oulevey@cern.ch> - 2.0.0-7
- Fix Requires: for new plugins

* Mon May 07 2018 Thomas Oulevey <thomas.oulevey@cern.ch> - 2.0.0-6
- CentOS 7.5 first version

* Fri Apr 06 2018 Thomas Oulevey <thomas.oulevey@cern.ch> - 2.0.0-4
- Split main locmap script and plugins

* Fri Apr 06 2018 Thomas Oulevey <thomas.oulevey@cern.ch> - 2.0.0-3
- Version 2.0.0

* Mon Mar 13 2017 Thomas Oulevey <thomas.oulevey@cern.ch> - 1.0-11
- Fix guessdomain for TN

* Tue Mar 07 2017 Thomas Oulevey <thomas.oulevey@cern.ch> - 1.0-10
- Fix building missing use case

* Fri Feb 03 2017 Thomas Oulevey <thomas.oulevey@cern.ch> - 1.0-9
- Fix cn method, for none xldap Linux computers

* Mon Dec 05 2016 Thomas Oulevey <thomas.oulevey@cern.ch> - 1.0-5
- Fix guessdomain

* Mon Dec 05 2016 Thomas Oulevey <thomas.oulevey@cern.ch> - 1.0-4
- Obsolete ncm* lcm*

* Tue Nov 29 2016 Thomas Oulevey <thomas.oulevey@cern.ch> - 1.0-1
- Add lcm binary with deprecation message
- Rebuild for 7.3 release

* Mon Nov 21 2016 Aris Boutselis <aris.boutselis@cern.ch> - 1.0-0
- Initial version
